import { IQueryHandler, QueryHandler } from '@nestjs/cqrs';
import { AD_REPOSITORY } from '@modules/ad/ad.di-tokens';
import { AdRepositoryPort } from '../../ports/ad.repository.port';
import { Inject } from '@nestjs/common';
import { AdEntity } from '../../../domain/ad.entity';
import { FindAdsByUserIdQuery } from './find-ads-by-user-id.query';

@QueryHandler(FindAdsByUserIdQuery)
export class FindAdsByUserIdQueryHandler implements IQueryHandler {
  constructor(
    @Inject(AD_REPOSITORY)
    private readonly repository: AdRepositoryPort,
  ) {}
  async execute(query: FindAdsByUserIdQuery): Promise<AdEntity[]> {
    return await this.repository.findAll(
      {
        userUuid: query.userId,
      },
      {
        waypoints: true,
        schedule: true,
      },
    );
  }
}
